<?
/*/////////////////////////////////////////////////////////////////////////////////////////////////[ ]
 α׷  :  Tycoon Series Layout Class ver 1.0
         :  Ÿ
         :  2002 2 5
 homepage  :  http://www.tycoon.co.kr
 Email         :  tycoon@tycoon.co.kr
            :  ̾ƿ Ŭ
   ȯ   :  , Php4, MySql
 License 
::  ҽ ۱  ǵ  Ǹ Tycoon.co.kr( Tycoon  Ÿ) ֽϴ. 
:: Ÿ ø  ۱ úκ Ѽϸ ȵ˴ϴ.
:: ۱ ǥô 󿡼 HTML ҽ ̴  PHP ҽ ܿ ġ  մϴ.
:: , α׷ ҽ, HTML ҽ ̼   ¹ ϴܿ ִ īǶƮ ũ Դϴ.
:: ۱ ǥô  ۼ ĸ ϸ     մϴ
:: ۱ ǥϰ    Ѿ  մϴ. 
:: ҽ    , ؼ    ϴ.
::  뵵 ҽ Ͽ    ۱  κ ̸   Դϴ.
:: Ÿ ø   ̿  ϴ.
:: Ÿ  ҽ  / ǹ ϴ.
:: Ÿ ø   ߻ϴ ؿ ؼ Ÿ å  ʽϴ.
::  Ϸ Ǽ. *^^*
//////////////////////////////////////////////////////////////////////////////////////////////// [ ]*/

class Layout_Class {
	var $LayoutPass, $ClassVars;
	var $contents = array();
	function Layout_Class($ClassVars) {
		$this->LayoutPass = $ClassVars[root_dir]."/layout/".$ClassVars[layout]."/";
		$this->ClassVars = $ClassVars;
	}
	///////////////////////////////////////////////////////////////////// [Default_define]
	function Default_define() {
		$this->contents[ROOT_URL] = $this->ClassVars[root_url];
		$this->contents[IMAGE_URL] = $this->ClassVars[image_url];
		$this->contents[TYPE] = $this->ClassVars[type];
		$this->contents[PAGE] = $this->ClassVars[page];
		$this->contents[SORT] = $this->ClassVars[sort];
		$this->contents[KEY] = urlencode($this->ClassVars[key]);
		$this->contents[KEYFIELD] = $this->ClassVars[keyfield];
	}
	///////////////////////////////////////////////////////////////////// [Print_view]
	function Print_view($filename, $contents="", $view_contents="", $loop_contents="", $loop_num="", $return="") {
		$result = $this->File_read($filename, $contents, $view_contents, $loop_contents, $loop_num);
		echo $result;
	}
	///////////////////////////////////////////////////////////////////// [Return_view]
	function Return_view($filename, $contents="", $view_contents="", $loop_contents="", $loop_num="") {
		$result = $this->File_read($filename, $contents, $view_contents, $loop_contents, $loop_num);
		return $result;
	}
	///////////////////////////////////////////////////////////////////// [File_read]
	function File_read($filename, $contents, $view_contents, $loop_contents, $loop_num) {
		if($filename) { 
			$this->contents = $contents;
			$this->view_contents = $view_contents;
			$this->Default_define();
			
			$file = $this->LayoutPass .$filename;
			$line = file($file);
			while(list($key, $val) = each($line)) {
				if(ereg("<!--%%%LOOPSTART%%%-->", $val, $regs)) {
					$val = "";
					$loop = "y";
				} else if(ereg("<!--%%%LOOPEND%%%-->", $val, $regs)) {
					$val = "";
					$loop = "";
					$result .= $this->Loop_view($loop_var, $loop_contents, $loop_num);
					unset($loop_var);
				} else if(ereg("<!--@@[A-Z0-9_]+@@-->", $val, $regs)) $hidden_line = $this->Line_confirm($val);
				else if(ereg("<!--@@@END@@@-->", $val, $regs)) $hidden_line = "";
				
				if($loop) $loop_var[$key] = $val;
				else if(!$hidden_line) {
					$val = ereg_replace("<!--@@[A-Z0-9_]+@@-->", "", $val);
					$val = ereg_replace("<!--@@@END@@@-->", "", $val);
					$result .= $this->Split_line($val);
				}
			}
		} else {
            while(list($key, $val ) = each($contents)) {
      			$result .= $contents[$key];
            }
		}
		return $result;
	}
	///////////////////////////////////////////////////////////////////// [Loop_view]
	function Loop_view($loop_var, $loop_contents, $loop_num) {
		for($i=0; $i<$loop_num; $i++) {
			$this->Loop_define($loop_contents, $i);
			$result .= $this->Loop_contents($loop_var);
		}
		return $result;
	}
	///////////////////////////////////////////////////////////////////// [Loop_define]
	function Loop_define($loop_contents, $i) {
		while(list($key, $val) = each($loop_contents)) {
			$this->contents[$key] = $val[$i];
		}
	}
	///////////////////////////////////////////////////////////////////// [Loop_contents]
	function Loop_contents($loop_var) {
		while(list($key, $val) = each($loop_var)) {
			if(ereg("<!--@@[A-Z0-9_]+@@-->", $val, $regs)) $hidden_line = $this->Line_confirm($val);
			else if(ereg("<!--@@@END@@@-->", $val, $regs)) $hidden_line = "";
			if(!$hidden_line) {
				$val = ereg_replace("<!--@@[A-Z0-9_]+@@-->", "", $val);
				$val = ereg_replace("<!--@@@END@@@-->", "", $val);
				$result .= $this->Split_line($val);
			}
		}
		return $result;
	}
	///////////////////////////////////////////////////////////////////// [Line_confirm]
	function Line_confirm($what) {
		$what = trim($what);
		for($i=0; $i<sizeof($this->view_contents); $i++) {
			$val = "<!--@@".$this->view_contents[$i]."@@-->";
			if($what == $val) $view = "y";
		}
		$hidden = (!$view) ? "y": "";
		return $hidden;
	}
	///////////////////////////////////////////////////////////////////// [Split_line]
	function Split_line($line) {
		$split_val = preg_split("({[A-Z0-9_]+})", $line);
		
		for($i=0; $i<sizeof($split_val)-1; $i++) {
			if(ereg("(\{[A-Z0-9_]+\})", $line, $regs)) {
				$print = $this->Print_define($regs[1]);
				$re = str_replace("{", "\\{", $regs[1]);
				$re = str_replace("}", "\\}", $re);
				$line = ereg_replace($re,"$print",$line);
			}
		}
		return $line;
	}
	///////////////////////////////////////////////////////////////////// [Print_define]
	function Print_define($what) {
		$what_val = str_replace("{", "", $what);
		$what_val = str_replace("}", "", $what_val);
		$print = $this->contents[$what_val];
		return $print;
	}
}
?>